import java.util.Arrays;

public class ArrayList<E> {

    Object[] arr;

    public ArrayList() {
        arr= new Object[0];
    }

    public Object[] getArr() {
        return arr;
    }

    public void setArr(Object[] arr) {
        this.arr = arr;
    }

    public ArrayList(int size) {
        arr=new Object[size];
    }


    public int size() {
        return arr.length;
    }

    public boolean add(E element) {
        Object[] temp = Arrays.copyOf(arr,arr.length+1);
        temp[temp.length-1] = element;
        arr = temp;
        return true;
    }

    public void add(int i, E element){
        Object[] arr1 =  Arrays.copyOfRange(arr, 0, i);
        Object[] arr2 = Arrays.copyOfRange(arr, i, arr.length);
        arr=arr1;
        add(element);
        arr=merge(arr,arr2);
    }

    public Object get(int index){
        return arr[index];
    }

    public void remove(int i) {
        Object[] arr1 = Arrays.copyOfRange(arr, 0, i);
        Object[] arr2 = Arrays.copyOfRange(arr, i+1, arr.length);
        arr =merge(arr1,arr2);

        }

        public Object[] merge(Object[] arr1, Object[] arr2){
            Object[] arrMerge = new Object[arr1.length+arr2.length];
            int counter = 0;
            for(Object el : arr1) {
                arrMerge[counter]=el;
                counter++;
            }
            for (Object el : arr2) {
                arrMerge [counter] = el;
                counter++;
                }
                return arrMerge;
        }

     public void set(int index, Object obj){
        arr[index]= obj;
     }

     public void clear(){
        arr=new Object[0];
     }

    public boolean isEmpty() {
        if(arr.length==0){return true; }
        return false;
    }

    public boolean contains(Object o){
     for(Object el : arr){
         if(el==o){return true;}
     }
        return false;
    }

    public int indexOf(Object o){
        for(int i=0; i<arr.length; i++){
            if (arr[i]==o){return i;}
        }
        return -1;
    }
}
